commit 5f000cb08c45978f6ec920f2f76f2362a378b2bb
Author: Vojtěch Bartička <aitakaitov@gmail.com>
Date:   Tue May 17 19:52:24 2022 +0200

    Added database migration

diff --git a/Backend/Backend/Migrations/20220517175136_V1.cs b/Backend/Backend/Migrations/20220517175136_V1.cs
new file mode 100644
index 0000000..7829abf
--- /dev/null
+++ b/Backend/Backend/Migrations/20220517175136_V1.cs
@@ -0,0 +1,470 @@
+﻿using System;
+using Microsoft.EntityFrameworkCore.Migrations;
+
+#nullable disable
+
+namespace RestAPI.Migrations
+{
+    public partial class V1 : Migration
+    {
+        protected override void Up(MigrationBuilder migrationBuilder)
+        {
+            migrationBuilder.CreateTable(
+                name: "Classes",
+                columns: table => new
+                {
+                    Id = table.Column<Guid>(type: "uuid", nullable: false),
+                    Name = table.Column<string>(type: "text", nullable: false),
+                    Description = table.Column<string>(type: "text", nullable: false),
+                    Color = table.Column<string>(type: "text", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_Classes", x => x.Id);
+                });
+
+            migrationBuilder.CreateTable(
+                name: "ConfigurationItems",
+                columns: table => new
+                {
+                    Id = table.Column<Guid>(type: "uuid", nullable: false),
+                    Value = table.Column<string>(type: "text", nullable: false),
+                    Key = table.Column<string>(type: "text", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_ConfigurationItems", x => x.Id);
+                });
+
+            migrationBuilder.CreateTable(
+                name: "DocumentContents",
+                columns: table => new
+                {
+                    Id = table.Column<Guid>(type: "uuid", nullable: false),
+                    Content = table.Column<string>(type: "text", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_DocumentContents", x => x.Id);
+                });
+
+            migrationBuilder.CreateTable(
+                name: "TagCategories",
+                columns: table => new
+                {
+                    Id = table.Column<Guid>(type: "uuid", nullable: false),
+                    Name = table.Column<string>(type: "text", nullable: true),
+                    Color = table.Column<string>(type: "text", nullable: true),
+                    Description = table.Column<string>(type: "text", nullable: true),
+                    DisabledForAnnotators = table.Column<bool>(type: "boolean", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_TagCategories", x => x.Id);
+                });
+
+            migrationBuilder.CreateTable(
+                name: "Users",
+                columns: table => new
+                {
+                    Id = table.Column<Guid>(type: "uuid", nullable: false),
+                    Username = table.Column<string>(type: "text", nullable: true),
+                    Password = table.Column<string>(type: "text", nullable: true),
+                    Name = table.Column<string>(type: "text", nullable: true),
+                    Surname = table.Column<string>(type: "text", nullable: true),
+                    Role = table.Column<int>(type: "integer", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_Users", x => x.Id);
+                });
+
+            migrationBuilder.CreateTable(
+                name: "Tags",
+                columns: table => new
+                {
+                    Id = table.Column<Guid>(type: "uuid", nullable: false),
+                    CategoryId = table.Column<Guid>(type: "uuid", nullable: false),
+                    Name = table.Column<string>(type: "text", nullable: false),
+                    Description = table.Column<string>(type: "text", nullable: false),
+                    Color = table.Column<string>(type: "text", nullable: false),
+                    SentimentEnabled = table.Column<bool>(type: "boolean", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_Tags", x => x.Id);
+                    table.ForeignKey(
+                        name: "FK_Tags_TagCategories_CategoryId",
+                        column: x => x.CategoryId,
+                        principalTable: "TagCategories",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                });
+
+            migrationBuilder.CreateTable(
+                name: "Documents",
+                columns: table => new
+                {
+                    Id = table.Column<Guid>(type: "uuid", nullable: false),
+                    Name = table.Column<string>(type: "text", nullable: true),
+                    Length = table.Column<int>(type: "integer", nullable: false),
+                    ContentId = table.Column<Guid>(type: "uuid", nullable: true),
+                    DateAdded = table.Column<DateTime>(type: "timestamp with time zone", nullable: false),
+                    UserAddedId = table.Column<Guid>(type: "uuid", nullable: true),
+                    RequiredAnnotations = table.Column<int>(type: "integer", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_Documents", x => x.Id);
+                    table.ForeignKey(
+                        name: "FK_Documents_DocumentContents_ContentId",
+                        column: x => x.ContentId,
+                        principalTable: "DocumentContents",
+                        principalColumn: "Id");
+                    table.ForeignKey(
+                        name: "FK_Documents_Users_UserAddedId",
+                        column: x => x.UserAddedId,
+                        principalTable: "Users",
+                        principalColumn: "Id");
+                });
+
+            migrationBuilder.CreateTable(
+                name: "SubTags",
+                columns: table => new
+                {
+                    Id = table.Column<Guid>(type: "uuid", nullable: false),
+                    Name = table.Column<string>(type: "text", nullable: false),
+                    Description = table.Column<string>(type: "text", nullable: false),
+                    TagId = table.Column<Guid>(type: "uuid", nullable: false),
+                    SentimentEnabled = table.Column<bool>(type: "boolean", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_SubTags", x => x.Id);
+                    table.ForeignKey(
+                        name: "FK_SubTags_Tags_TagId",
+                        column: x => x.TagId,
+                        principalTable: "Tags",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                });
+
+            migrationBuilder.CreateTable(
+                name: "Annotations",
+                columns: table => new
+                {
+                    Id = table.Column<Guid>(type: "uuid", nullable: false),
+                    DocumentId = table.Column<Guid>(type: "uuid", nullable: false),
+                    UserId = table.Column<Guid>(type: "uuid", nullable: false),
+                    UserAssignedId = table.Column<Guid>(type: "uuid", nullable: false),
+                    DateAssigned = table.Column<DateTime>(type: "timestamp with time zone", nullable: false),
+                    State = table.Column<int>(type: "integer", nullable: false),
+                    DateLastChanged = table.Column<DateTime>(type: "timestamp with time zone", nullable: false),
+                    Note = table.Column<string>(type: "text", nullable: false),
+                    CachedDocumentHTML = table.Column<string>(type: "text", nullable: false),
+                    CachedStartPositions = table.Column<string>(type: "text", nullable: false),
+                    CachedLengths = table.Column<string>(type: "text", nullable: false),
+                    CachedClosingPositions = table.Column<string>(type: "text", nullable: false),
+                    CachedClosingLengths = table.Column<string>(type: "text", nullable: false),
+                    CachedCSS = table.Column<string>(type: "text", nullable: false),
+                    LastModifiedTagId = table.Column<Guid>(type: "uuid", nullable: true),
+                    ModifiedType = table.Column<int>(type: "integer", nullable: false),
+                    Discriminator = table.Column<string>(type: "text", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_Annotations", x => x.Id);
+                    table.ForeignKey(
+                        name: "FK_Annotations_Documents_DocumentId",
+                        column: x => x.DocumentId,
+                        principalTable: "Documents",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                    table.ForeignKey(
+                        name: "FK_Annotations_Users_UserAssignedId",
+                        column: x => x.UserAssignedId,
+                        principalTable: "Users",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                    table.ForeignKey(
+                        name: "FK_Annotations_Users_UserId",
+                        column: x => x.UserId,
+                        principalTable: "Users",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                });
+
+            migrationBuilder.CreateTable(
+                name: "AnnotationClass",
+                columns: table => new
+                {
+                    AnnotationsId = table.Column<Guid>(type: "uuid", nullable: false),
+                    ClassesId = table.Column<Guid>(type: "uuid", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_AnnotationClass", x => new { x.AnnotationsId, x.ClassesId });
+                    table.ForeignKey(
+                        name: "FK_AnnotationClass_Annotations_AnnotationsId",
+                        column: x => x.AnnotationsId,
+                        principalTable: "Annotations",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                    table.ForeignKey(
+                        name: "FK_AnnotationClass_Classes_ClassesId",
+                        column: x => x.ClassesId,
+                        principalTable: "Classes",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                });
+
+            migrationBuilder.CreateTable(
+                name: "AnnotationFinalAnnotation",
+                columns: table => new
+                {
+                    AnnotationsId = table.Column<Guid>(type: "uuid", nullable: false),
+                    FinalAnnotationsId = table.Column<Guid>(type: "uuid", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_AnnotationFinalAnnotation", x => new { x.AnnotationsId, x.FinalAnnotationsId });
+                    table.ForeignKey(
+                        name: "FK_AnnotationFinalAnnotation_Annotations_AnnotationsId",
+                        column: x => x.AnnotationsId,
+                        principalTable: "Annotations",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                    table.ForeignKey(
+                        name: "FK_AnnotationFinalAnnotation_Annotations_FinalAnnotationsId",
+                        column: x => x.FinalAnnotationsId,
+                        principalTable: "Annotations",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                });
+
+            migrationBuilder.CreateTable(
+                name: "AnnotationTags",
+                columns: table => new
+                {
+                    Id = table.Column<Guid>(type: "uuid", nullable: false),
+                    AnnotationId = table.Column<Guid>(type: "uuid", nullable: false),
+                    TagId = table.Column<Guid>(type: "uuid", nullable: false),
+                    SubTagId = table.Column<Guid>(type: "uuid", nullable: true),
+                    Instance = table.Column<Guid>(type: "uuid", nullable: false),
+                    Note = table.Column<string>(type: "text", nullable: false),
+                    Position = table.Column<int>(type: "integer", nullable: false),
+                    Length = table.Column<int>(type: "integer", nullable: false),
+                    Sentiment = table.Column<int>(type: "integer", nullable: true),
+                    SelectedText = table.Column<string>(type: "text", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_AnnotationTags", x => x.Id);
+                    table.ForeignKey(
+                        name: "FK_AnnotationTags_Annotations_AnnotationId",
+                        column: x => x.AnnotationId,
+                        principalTable: "Annotations",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                    table.ForeignKey(
+                        name: "FK_AnnotationTags_SubTags_SubTagId",
+                        column: x => x.SubTagId,
+                        principalTable: "SubTags",
+                        principalColumn: "Id");
+                    table.ForeignKey(
+                        name: "FK_AnnotationTags_Tags_TagId",
+                        column: x => x.TagId,
+                        principalTable: "Tags",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                });
+
+            migrationBuilder.CreateTable(
+                name: "FinalAnnotationTags",
+                columns: table => new
+                {
+                    Id = table.Column<Guid>(type: "uuid", nullable: false),
+                    AnnotationId = table.Column<Guid>(type: "uuid", nullable: false),
+                    IsFinal = table.Column<bool>(type: "boolean", nullable: false),
+                    TagId = table.Column<Guid>(type: "uuid", nullable: false),
+                    SubTagId = table.Column<Guid>(type: "uuid", nullable: true),
+                    Instance = table.Column<Guid>(type: "uuid", nullable: false),
+                    Note = table.Column<string>(type: "text", nullable: false),
+                    Position = table.Column<int>(type: "integer", nullable: false),
+                    Length = table.Column<int>(type: "integer", nullable: false),
+                    Sentiment = table.Column<int>(type: "integer", nullable: true),
+                    SelectedText = table.Column<string>(type: "text", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_FinalAnnotationTags", x => x.Id);
+                    table.ForeignKey(
+                        name: "FK_FinalAnnotationTags_Annotations_AnnotationId",
+                        column: x => x.AnnotationId,
+                        principalTable: "Annotations",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                    table.ForeignKey(
+                        name: "FK_FinalAnnotationTags_SubTags_SubTagId",
+                        column: x => x.SubTagId,
+                        principalTable: "SubTags",
+                        principalColumn: "Id");
+                    table.ForeignKey(
+                        name: "FK_FinalAnnotationTags_Tags_TagId",
+                        column: x => x.TagId,
+                        principalTable: "Tags",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                });
+
+            migrationBuilder.CreateTable(
+                name: "FinalAnnotationTagUser",
+                columns: table => new
+                {
+                    FinalAnnotationTagsId = table.Column<Guid>(type: "uuid", nullable: false),
+                    UsersId = table.Column<Guid>(type: "uuid", nullable: false)
+                },
+                constraints: table =>
+                {
+                    table.PrimaryKey("PK_FinalAnnotationTagUser", x => new { x.FinalAnnotationTagsId, x.UsersId });
+                    table.ForeignKey(
+                        name: "FK_FinalAnnotationTagUser_FinalAnnotationTags_FinalAnnotationT~",
+                        column: x => x.FinalAnnotationTagsId,
+                        principalTable: "FinalAnnotationTags",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                    table.ForeignKey(
+                        name: "FK_FinalAnnotationTagUser_Users_UsersId",
+                        column: x => x.UsersId,
+                        principalTable: "Users",
+                        principalColumn: "Id",
+                        onDelete: ReferentialAction.Cascade);
+                });
+
+            migrationBuilder.CreateIndex(
+                name: "IX_AnnotationClass_ClassesId",
+                table: "AnnotationClass",
+                column: "ClassesId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_AnnotationFinalAnnotation_FinalAnnotationsId",
+                table: "AnnotationFinalAnnotation",
+                column: "FinalAnnotationsId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_Annotations_DocumentId",
+                table: "Annotations",
+                column: "DocumentId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_Annotations_UserAssignedId",
+                table: "Annotations",
+                column: "UserAssignedId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_Annotations_UserId",
+                table: "Annotations",
+                column: "UserId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_AnnotationTags_AnnotationId",
+                table: "AnnotationTags",
+                column: "AnnotationId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_AnnotationTags_SubTagId",
+                table: "AnnotationTags",
+                column: "SubTagId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_AnnotationTags_TagId",
+                table: "AnnotationTags",
+                column: "TagId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_Documents_ContentId",
+                table: "Documents",
+                column: "ContentId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_Documents_UserAddedId",
+                table: "Documents",
+                column: "UserAddedId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_FinalAnnotationTags_AnnotationId",
+                table: "FinalAnnotationTags",
+                column: "AnnotationId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_FinalAnnotationTags_SubTagId",
+                table: "FinalAnnotationTags",
+                column: "SubTagId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_FinalAnnotationTags_TagId",
+                table: "FinalAnnotationTags",
+                column: "TagId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_FinalAnnotationTagUser_UsersId",
+                table: "FinalAnnotationTagUser",
+                column: "UsersId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_SubTags_TagId",
+                table: "SubTags",
+                column: "TagId");
+
+            migrationBuilder.CreateIndex(
+                name: "IX_Tags_CategoryId",
+                table: "Tags",
+                column: "CategoryId");
+        }
+
+        protected override void Down(MigrationBuilder migrationBuilder)
+        {
+            migrationBuilder.DropTable(
+                name: "AnnotationClass");
+
+            migrationBuilder.DropTable(
+                name: "AnnotationFinalAnnotation");
+
+            migrationBuilder.DropTable(
+                name: "AnnotationTags");
+
+            migrationBuilder.DropTable(
+                name: "ConfigurationItems");
+
+            migrationBuilder.DropTable(
+                name: "FinalAnnotationTagUser");
+
+            migrationBuilder.DropTable(
+                name: "Classes");
+
+            migrationBuilder.DropTable(
+                name: "FinalAnnotationTags");
+
+            migrationBuilder.DropTable(
+                name: "Annotations");
+
+            migrationBuilder.DropTable(
+                name: "SubTags");
+
+            migrationBuilder.DropTable(
+                name: "Documents");
+
+            migrationBuilder.DropTable(
+                name: "Tags");
+
+            migrationBuilder.DropTable(
+                name: "DocumentContents");
+
+            migrationBuilder.DropTable(
+                name: "Users");
+
+            migrationBuilder.DropTable(
+                name: "TagCategories");
+        }
+    }
+}
